P3128 [USACO15DEC]最大流Max Flow (树上差分)

题目描述

Farmer John has installed a new system of N-1N1 pipes to transport milk between the NN stalls in his barn (2 \leq N \leq 50,0002N50,000), conveniently numbered 1 \ldots N1N. Each pipe connects a pair of stalls, and all stalls are connected to each-other via paths of pipes.

FJ is pumping milk between KK pairs of stalls (1 \leq K \leq 100,0001K100,000). For the iith such pair, you are told two stalls s_isi and t_iti, endpoints of a path along which milk is being pumped at a unit rate. FJ is concerned that some stalls might end up overwhelmed with all the milk being pumped through them, since a stall can serve as a waypoint along many of the KK paths along which milk is being pumped. Please help him determine the maximum amount of milk being pumped through any stall. If milk is being pumped along a path from s_isi to t_iti, then it counts as being pumped through the endpoint stalls s_isi and

t_iti, as well as through every stall along the path between them.

输入格式

The first line of the input contains NN and KK.

The next N-1N1 lines each contain two integers xx and yy (x \ne yxy) describing a pipe

between stalls xx and yy.

The next KK lines each contain two integers ss and tt describing the endpoint

stalls of a path through which milk is being pumped.

输出格式

An integer specifying the maximum amount of milk pumped through any stall in the

barn.

输入输出样例

输入 #1

5 10
3 4
1 5
4 2
5 4
5 4
5 4
3 5
4 3
4 3
1 3
3 5
5 4
1 5
3 4

输出 #1

9

思路:

对于多次修改一个询问的树上统计问题 我们可以直接树上差分解决问题 任意两个点的路径都可以差分成 u->lca(u,v) lca(u,v)->v 差分可以分为点差分和边差分 唯一的区别在于对lca的操作不同 这题我们显然可以用点差分 每次修改都维护一个数组 最后dfs扫一遍统计答案即可。(这题卡掉了vector(可能是我写疵了 re wa mle都有。。) 用链式前向星就可以过)

性质(一个点的真实权值是一个点子树内所有差分后的权值之和

#include<bits/stdc++.h>
using namespace std;
const double pi = acos(-1.0);
const int N = 5e4+7;
const int inf = 0x3f3f3f3f;
const double eps = 1e-6;
typedef long long ll;
const ll mod = 1e9+7;
struct edge{
    int next,v;
};
edge e[N<<1];
int head[N],cnt,f[N][30],d[N];
int val[N];
void add(int u,int v){
    e[++cnt]=(edge){head[u],v};
    head[u]=cnt;
}
int T;
void dfs(int u,int fa){
    d[u]=d[fa]+1; 
    for(int i=head[u];i;i=e[i].next){
        int v=e[i].v;
        if(v==fa) continue;
        f[v][0]=u;
        for(int j=1;j<=T;j++)
            f[v][j]=f[f[v][j-1]][j-1];
        dfs(v,u);
    }
}
int lca(int x,int y){
    if(d[x]>d[y]) swap(x,y);
    for(int i=T;i>=0;i--)
        if(d[f[y][i]]>=d[x]) y=f[y][i];
    if(x==y) return x;
    for(int i=T;i>=0;i--)
        if(f[x][i]!=f[y][i]) x=f[x][i],y=f[y][i];
    return f[x][0];
}
int ans=-inf;
void solve(int u,int fa){
    for(int i=head[u];i;i=e[i].next){
        int v=e[i].v;
        if(v==fa) continue;
        solve(v,u);
        val[u]+=val[v];
    }
    ans=max(ans,val[u]);
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n,k; cin>>n>>k;
    T=log2(n)+1;
    for(int i=1;i<n;i++){
        int u,v; cin>>u>>v;
        add(u,v); add(v,u);
    }
    dfs(1,0);
    for(int i=1;i<=k;i++){
        int s,t; cin>>s>>t;
        int LCA=lca(s,t);
        val[s]++; val[t]++; val[LCA]--; val[f[LCA][0]]--;
    }
    solve(1,0);
    cout<<ans<<endl;
}
View Code

猜你喜欢

转载自www.cnblogs.com/wmj6/p/11426754.html
今日推荐